<?

function theme_install_query($sql,$status = 1) {
  $output = "<div class='sql'>";
  $output .= nl2br(htmlentities($sql)) ." ";

  if ($status) {
    $output .= "<span style=\"color: green;\">OK</span>\n";
  }
  else {
    $output .= "<span style=\"color: red;\">FAILED</span>\n";
  }
  $output .= "</div>";
  return $output;

}

function install_sql($sql) {
  $result = db_query($sql);
  $status = ($result) ?  1 :  0;
  print theme_install_query($sql,$status);
}

function install_data($module, $start) {
  $updates = array_slice(module_invoke($module, "registry", "updates") , ($start-- ? $start : 0));
  
  foreach ($updates as $date => $func) {
  
    $output .= "<strong>$date</strong><br />\n<pre>\n";
    
    $func = $module . "_".$func;
    
    /*
    * database portability
    */
    
    if (function_exists($func . "_" . $GLOBALS["db_type"])) {
      $func = $func . "_" . $GLOBALS["db_type"];
    }
    
    // workaround for install_sql problem
    ob_start();
    $func();
    $output .= ob_get_contents();
    ob_end_clean();
    variable_set("install_start", $date);
    $output .= "</pre>\n";

  }
  return $output;
}


function install_install($module) {
  $date = module_invoke($module, "registry", "version");
  
  $func = $module . "_install";
  if (function_exists($func . "_" . $GLOBALS["db_type"])) {
    $func = $func . "_" . $GLOBALS["db_type"];
  }
  
  // workaround for install_sql problem
  
  ob_start();
  $func();
  $output .= ob_get_contents();
  ob_end_clean();

  // at this point we can't help but assume the variables are available.
  variable_set($module . "_install_start", $date);
  $output .= "</pre>\n";

  return $output;
}

function install_wizards($module,$stage = 'pre') {
  $wizards = module_invoke($module,"registry","configs");
  $edit = $_POST['edit'];
  $finished = true;
  foreach (array_keys($wizards[$stage]) as $wiz) {
    if ($finished) {
      if (module_invoke($module, "config_$wiz"."_validate",$edit)) {
        $form .= module_invoke($module,"config_$wiz",$edit,1);
      } 
      else {
        $output = "<fieldset><legend>" . $wizards[$stage][$wiz] . "</legend>";
        $form .= form_hidden("submitted",$wiz);
        $form .= theme("box", "",  module_invoke($module, "install_help", $wiz));
        if ($edit['submitted'] == $wiz) {
          $form .= install_print_errors();
        }
        $form .= module_invoke($module,"config_$wiz",$edit,0);
        $finished = false;
      }
    }
  }
  $form .= form_submit("next >>");
  $output .= form($form) . "</fieldset>";

  if ($finished) {
    $output = '';
  }
  
  return $output;
}

function install_error($error) {
  global $install_errors;
  $install_errors[] = $error;
}

function install_print_errors() {
  global $install_errors;
  if (sizeof($install_errors) > 0) {
    foreach ($install_errors as $error) {
      $output .=  theme("error", $error);
    }
  }
  return $output;
}

function install_page() {
  global $user;
  $module = ($_GET["module"]) ? $_GET["module"] : "system";
  include_once "install/" . $module . ".install";
  $edit = $_POST["edit"];
  if (isset($_GET["op"])) {
    switch ($_POST["op"]) {
      case "Updates":
        $updates = module_invoke($module, "registry", "updates");
        $links = array( l("main page","index.php") , l("administration pages","index.php?q=admin"));
        $output .= theme_item_list($links);
        if ($edit["start"] == -1) {
          $output .= "No updates to perform.";
        }
        else {
          $output .= install_data($module, $edit["start"]);
        }
        $output .= "<br />Updates were attempted. If you see no failures above, you may proceed happily to the <a href=\"index.php?q=admin\">administration pages</a>. Otherwise, you may need to update your database manually.";
        break;
      default:
        $start = variable_get("update_start", 0);
        $dates[] = "All";
        $i = 1;
        foreach ($updates as $date => $sql) {
          $dates[$i++] = $date;
          if ($date == $start) {
            $selected = $i;
          }
        }
        $dates[$i] = "No updates available";

        $form = form_select("Perform updates from", "start", (isset($selected) ? $selected : -1), $dates, "This defaults to the first available update since the last update you peformed.");
        $form .= form_submit("Update");
        
        $output = form($form);
        break;
    }
  }
  else {
    $output = install_wizards($module,'pre');  
  

    if ($output == '') {
      $output = "We are now going to attempt to run the database.. please hold";
      $output = install_install($module);
    }
  }
  print install_page_header("Drupal Setup");
  print $output;
  print install_page_footer();

}


function install_page_header($title) {
  $output =  '
      <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
      <head>
      <title>' . $title . '</title>
      <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
      <link type="text/css" rel="stylesheet" href="themes/xtemplate/xtemplate.css" />
      <style>
      #content {
      padding: 1.5em;
      width: 40em;
      margin: 0em auto;
      }
      input.form-submit { float: right }
      input, select {
      border: 1px solid #aaa;
      }
      input {
      padding: 0.1em;
      }
      .sql {
        margin : 5px;
        background-color: #eee;
        padding: 0.75em 1.5em;
        font-size: 12px;
        border: 1px solid #ddd;
      }

      input:focus, select:focus {
      border: 1px solid #000;
      background: #ffc;
      }
      fieldset {
      display: block;
      margin-bottom: 2em;
      }
      legend {
        font-weight: bold;
      }

      </style>
      </head>
      <body>

      <link rel="stylesheet" type="text/css" media="print" href="misc/print.css" />
      <style type="text/css" title="layout" media="Screen">
        @import url("misc/drupal.css");
      </style>
      <div id="header">
      <img src="themes/xtemplate/images/druplicon.gif" alt="Druplicon" />
      </div>
      <div id="content">
      ';

  return $output;
}

function install_page_footer() {
  return "</div></body></html>";
}


?>
